=== added file '.project'
--- .project	1970-01-01 00:00:00 +0000
+++ .project	2011-03-28 11:57:49 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>UF-163: Accounting Periods</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.python.pydev.PyDevBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.python.pydev.pythonNature</nature>
+	</natures>
+</projectDescription>

=== added file '.pydevproject'
--- .pydevproject	1970-01-01 00:00:00 +0000
+++ .pydevproject	2011-03-28 11:57:49 +0000
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<?eclipse-pydev version="1.0"?>
+
+<pydev_project>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_INTERPRETER">Default</pydev_property>
+<pydev_property name="org.python.pydev.PYTHON_PROJECT_VERSION">python 2.6</pydev_property>
+</pydev_project>

=== added directory 'account_period_closing_level'
=== added file 'account_period_closing_level/__init__.py'
--- account_period_closing_level/__init__.py	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/__init__.py	2011-03-28 11:57:49 +0000
@@ -0,0 +1,26 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import account
+import account_period_closing_level
+import wizard
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_period_closing_level/__openerp__.py'
--- account_period_closing_level/__openerp__.py	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/__openerp__.py	2011-03-28 11:57:49 +0000
@@ -0,0 +1,42 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name": "Account Period for MSF",
+    "version": "1.0",
+    "depends": ["account"],
+    "author" : "MSF: Matthieu Dietrich",
+    "category": "General/Standard",
+    "description": """
+    This module adds states to the fiscal years and accounting periods,
+    with a new wizard to create tem automatically.
+    
+    """,
+    "init_xml": [],
+    'update_xml': [
+        'account_period_closing_level_view.xml',
+        'wizard/account_period_create_view.xml',
+    ],
+    'demo_xml': [],
+    'installable': True,
+    'active': False,
+#    'certificate': 'certificate',
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_period_closing_level/account_period_closing_level.py'
--- account_period_closing_level/account_period_closing_level.py	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/account_period_closing_level.py	2011-03-28 11:57:49 +0000
@@ -0,0 +1,65 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+from osv import fields, osv
+
+class account_period_closing_level(osv.osv):
+    _inherit = "account.period"
+    
+    # To avoid issues with existing OpenERP code (account move line for example),
+    # the state are:
+    #  - 'created' for Draft
+    #  - 'draft' for Open
+    #  - 'done' for HQ-Closed
+    def _get_state(self, cursor, user_id, context=None):
+        return (('created','Draft'), \
+                ('draft', 'Open'), \
+                ('field-closed', 'Field-Closed'), \
+                ('mission-closed', 'Mission-Closed'), \
+                ('done', 'HQ-Closed'))
+    
+    def action_set_state(self, cr, uid, ids, context):
+        
+        if context['state']:
+            state = context['state']
+            if state == 'done':
+                journal_state = 'done'
+            else:
+                journal_state = 'draft'
+            for id in ids:
+                cr.execute('update account_journal_period set state=%s where period_id=%s', (journal_state, id))
+                cr.execute('update account_period set state=%s where id=%s', (state, id))
+        return True
+
+    _columns = {
+        'special': fields.boolean('Opening/Closing Period', size=12,
+            help="These periods can overlap.", readonly=True),
+        'state': fields.selection(_get_state, 'State', readonly=True,
+            help='HQ opens a monthly period. After validation, it will be closed by the different levels.'),
+    }
+    
+    _defaults = {
+        'state': 'created'
+    }
+
+account_period_closing_level()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_period_closing_level/account_period_closing_level_view.xml'
--- account_period_closing_level/account_period_closing_level_view.xml	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/account_period_closing_level_view.xml	2011-03-28 11:57:49 +0000
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+    <data>
+    
+        <record id="view_account_fiscalyear_level_form" model="ir.ui.view">
+            <field name="name">account.fiscalyear_level.form</field>
+            <field name="model">account.fiscalyear</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="account.view_account_fiscalyear_form"/>
+            <field name="arch" type="xml">
+                <data>
+                    <button name="create_period" position="replace"/>
+                    <button name="create_period3" position="replace"/>
+                </data>
+            </field>
+        </record>
+        
+        <record id="view_account_period_closing_level_form" model="ir.ui.view">
+            <field name="name">account.period_closing_level.form</field>
+            <field name="model">account.period</field>
+            <field name="type">form</field>
+            <field name="inherit_id" ref="account.view_account_period_form"/>
+            <field name="arch" type="xml">
+                <data>
+                    <field name="code" position="replace"/>
+                    <field name="company_id" position="replace"/>
+	                <button name="action_draft" position="replace">
+	                    <group col="6" colspan="2">
+                            <button name="action_set_state" states="field-closed" confirm="Are you sure you want to re-open this period?" string="Re-open period (Field)" type="object" icon="gtk-go-back" context="{'state': 'draft'}"/>
+                            <button name="action_set_state" states="mission-closed" confirm="Are you sure you want to re-open this period?" string="Re-open period (Mission)" type="object" icon="gtk-go-back" context="{'state': 'field-closed'}"/>
+                            <button name="action_set_state" states="created" confirm="Are you sure you want to open this period?" string="Open period" type="object" icon="gtk-go-forward" context="{'state': 'draft'}"/>
+                            <button name="action_set_state" states="draft" confirm="Are you sure you want to close this period?" string="Close period (Field)" type="object" icon="gtk-go-forward" context="{'state': 'field-closed'}"/>
+                            <button name="action_set_state" states="field-closed" confirm="Are you sure you want to close this period?" string="Close period (Mission)" type="object" icon="gtk-go-forward" context="{'state': 'mission-closed'}"/>
+                            <button name="action_set_state" states="mission-closed" confirm="Are you sure you want to close this period?" string="Close period (HQ)" type="object" icon="gtk-go-forward" context="{'state': 'done'}"/>
+                        </group>
+	                </button>
+                </data>
+            </field>
+        </record>
+
+        <record id="view_account_period_closing_level_search" model="ir.ui.view">
+            <field name="name">account.period_closing_level.search</field>
+            <field name="model">account.period</field>
+            <field name="type">search</field>
+            <field name="inherit_id" ref="account.view_account_period_search"/>
+            <field name="arch" type="xml">
+                <filter name="draft" position="replace">
+                    <filter string="To Close" name="draft" domain="[('state','!=','done')]" icon="terp-dialog-close"/>
+                </filter>
+            </field>
+        </record>
+        
+        <record id="view_account_period_closing_level_tree" model="ir.ui.view">
+            <field name="name">account.period_closing_level.tree</field>
+            <field name="model">account.period</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.view_account_period_tree"/>
+            <field name="arch" type="xml">
+                <tree string="Period" position="replace">
+	                <tree colors="blue:state in ('created');gray:state in ('done') " string="Period">
+	                    <field name="name"/>
+	                    <field name="code"/>
+	                    <field name="date_start"/>
+	                    <field name="date_stop"/>
+	                    <field name="special"/>
+	                    <field name="state"/>
+                    </tree>
+                </tree>
+            </field>
+        </record>
+        
+        <record id="action_account_period_closing_level_tree" model="ir.actions.act_window">
+            <field name="name">Close a Period</field>
+            <field name="res_model">account.period</field>
+            <field name="inherit_id" ref="account.action_account_period_tree"/>
+            <field name="domain">[('state','!=','created')]</field>
+            <field name="context">{'search_default_draft': 1}</field>
+            <field name="help">A period is a fiscal period of time during which accounting entries should be recorded for accounting related activities. Monthly period is the norm but depending on your countries or company needs, you could also have quarterly periods. Closing a period will make it impossible to record new accounting entries, all new entries should then be made on the following open period. Close a period when you do not want to record new entries and want to lock this period for tax related calculation.</field>
+        </record>
+        
+        <menuitem action="action_account_period_closing_level_tree"
+            id="account.menu_action_account_period_close_tree"
+            parent="account.menu_account_end_year_treatments"
+            sequence="0"/>
+        
+    
+    </data>
+</openerp>
\ No newline at end of file

=== added directory 'account_period_closing_level/wizard'
=== added file 'account_period_closing_level/wizard/__init__.py'
--- account_period_closing_level/wizard/__init__.py	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/wizard/__init__.py	2011-03-28 11:57:49 +0000
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import account_period_create
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_period_closing_level/wizard/account_period_create.py'
--- account_period_closing_level/wizard/account_period_create.py	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/wizard/account_period_create.py	2011-03-28 11:57:49 +0000
@@ -0,0 +1,85 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import datetime
+from dateutil.relativedelta import relativedelta
+from osv import fields, osv
+
+class account_period_create(osv.osv):
+    _name="account.period.create"
+    
+    _columns = {
+        'fiscalyear': fields.selection([('current', 'Current FY'), ('next', 'Next FY')], 'Fiscal year', required=True)
+    }
+    
+    _defaults = {
+        'fiscalyear': 'current'
+    }
+    
+    
+    def account_period_create_periods(self, cr, uid, ids, context=None):
+        data = self.read(cr, uid, ids, [], context=context)[0]
+        if data['fiscalyear'] == 'next':
+            # Jan 1st of next year
+            start_date = datetime.date(datetime.date.today().year + 1, 1, 1)
+            end_date = datetime.date(datetime.date.today().year + 1, 12, 31)
+        else:
+            # First day of the current month
+            start_date = datetime.date(datetime.date.today().year, datetime.date.today().month, 1)
+            end_date = datetime.date(datetime.date.today().year, 12, 31)
+            
+        fiscalyear_id = self.pool.get('account.fiscalyear').create(cr,uid, {
+                            'name': 'FY %d' % (start_date.year),
+                            'code': 'FY%d' % (start_date.year),
+                            'date_start': start_date,
+                            'date_stop': end_date})
+        
+        ds = start_date
+        while ds < end_date:
+            de = ds + relativedelta(months=1, days=-1)
+
+            if de > end_date:
+                de = end_date
+
+            self.pool.get('account.period').create(cr, uid, {
+                'name': ds.strftime('%b %Y'),
+                'code': ds.strftime('%b %Y'),
+                'date_start': ds.strftime('%Y-%m-%d'),
+                'date_stop': de.strftime('%Y-%m-%d'),
+                'fiscalyear_id': fiscalyear_id,
+            })
+            ds = ds + relativedelta(months=1)
+            
+        for period_nb in (13, 14, 15):   
+            self.pool.get('account.period').create(cr, uid, {
+                'name': 'Period %d' % (period_nb),
+                'code': 'Period %d' % (period_nb),
+                'date_start': '%d-12-01' % (start_date.year),
+                'date_stop': '%d-12-31' % (start_date.year),
+                'fiscalyear_id': fiscalyear_id,
+                'special': True
+            })
+        
+        return {'type': 'ir.actions.act_window_close'}
+
+account_period_create()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_period_closing_level/wizard/account_period_create_view.xml'
--- account_period_closing_level/wizard/account_period_create_view.xml	1970-01-01 00:00:00 +0000
+++ account_period_closing_level/wizard/account_period_create_view.xml	2011-03-28 11:57:49 +0000
@@ -0,0 +1,32 @@
+<?xml version="1.0" encoding="utf-8"?>
+<openerp>
+    <data>
+        <record id="view_account_create_period" model="ir.ui.view">
+            <field name="name">account.period.create</field>
+            <field name="model">account.period.create</field>
+            <field name="type">form</field>
+            <field name="arch" type="xml">
+                <form string="Create Period">
+                    <field name="fiscalyear"/>
+                    <separator string="" colspan="4"/>
+                    <group colspan="4" col="6">
+                        <button icon="gtk-cancel" special="cancel" string="Cancel"/>
+                        <button icon="terp-gtk-go-back-rtl" string="Create Periods" name="account_period_create_periods" type="object"/>
+                    </group>
+                </form>
+            </field>
+        </record>
+
+        <record id="action_account_create_period" model="ir.actions.act_window">
+            <field name="name">Create Period</field>
+            <field name="res_model">account.period.create</field>
+            <field name="view_type">form</field>
+            <field name="view_mode">tree,form</field>
+            <field name="view_id" ref="view_account_create_period"/>
+        </record>
+
+        <menuitem action="action_account_create_period"
+            id="menu_action_account_create_period"
+            parent="account.next_id_23" />
+    </data>
+</openerp>

